=== debian/changelog ===
f3d (3.1.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Patch vtkF3DQuakeMDLImporter for FTBFS

 -- Francois Mazen <mzf@debian.org>  Tue, 22 Apr 2025 23:30:00 +0200
