=== debian/tests/control ===
Test-Command: f3d --version
Depends: f3d
Restrictions: superficial

Test-Command: f3d --help
Depends: f3d
Restrictions: superficial

Tests: check-cube-vtp, check-cube-step
Depends: f3d, xvfb, xauth, openimageio-tools
Restrictions: allow-stderr

Tests: check-cube-dae
Depends: f3d, xvfb, xauth, openimageio-tools
Architecture: !s390x
Restrictions: allow-stderr
